# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""

#Marcin �liwa
import os
import Mapa_PU
from PyQt5 import QtGui, uic
from PyQt5.QtGui import * 
from PyQt5.QtCore import * 
from Mapa_PU.kontroler import metody_globalne
from Mapa_PU.kontroler import komunikaty
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *

FORM_CLASS, _ = uic.loadUiType(os.path.join(os.path.dirname(__file__), 'nazwa_projektu_dialog.ui'))

class NazwaProjektuDialog(QDialog,FORM_CLASS):
    """Widok dla nazwy projektu"""
    def __init__(self,katalog,rodzic=None):
        super(NazwaProjektuDialog,self).__init__(rodzic)
        self.setupUi(self)
        self.__katalog=katalog
        self.setWindowFlags( Qt.Dialog | Qt.WindowTitleHint )
        self.setWindowIcon(QIcon('%s\\ikony\\Logo_BULiGL.ico' % Mapa_PU.upul_modul.root))
      
        
        
    def zmienNazweProjektu(self,text):
        """Reaguje na zmianę nazwy projektu"""
        
        if len(text)>0:
            self.__niePustaNazwa=True
        else:
            self.__niePustaNazwa=False
         
      
        
    def kontrolujKatalog(self):
        """Kontroluje czy projekt już istnieje
        :return wynik kontroli
        """
        nazwaProjektu=self.nazwaProjektu.text()
        
        if nazwaProjektu=='':
            komunikaty.blad(u"Brak nazwy projektu",u"Proszę podać nazwę projektu.")
            return False
        sciezka='%s//%s' % (self.__katalog,nazwaProjektu)
        if metody_globalne.czyJestKatalog(sciezka)==True:
            ret=komunikaty.pytanie_tak_nie(u"Błędna nazwa projektu",u"Projekt o nazwie '%s' już istnieje w podanym katalogu '%s'.\nCzy chcesz nadpisać projekt ?" % (nazwaProjektu,self.__katalog))
            if ret==0:
                try:
                    metody_globalne.usun(sciezka)
                    return True
                except Exception as e:
                    komunikaty.blad(u"Nie można usunąć projektu.", u'%s' % str(e).decode("windows-1250"))
                    return False
            else:
                self.nazwaProjektu.setFocus()
                self.nazwaProjektu.selectAll()
                return False
  
        return True
    
    def closeEvent(self, *args, **kwargs):
        """zamykanie widoku"""
        pass
     
            
    def accept(self):
        """Akceptacja kontroli"""
        if self.kontrolujKatalog()==False:
            return
        self.setResult(1)
        self.close()
    def reject(self):
        """Anulowanie kontroli"""
        self.setResult(0)
        self.close()
